clear all
close all
clc

% folder where the files like V3V100008_006_trainedAnnotator.mat are present - where the Annotation
% GUI saves them 
dirname = 'C:\Stuff\Research\Lockheed\scene_understanding_lm\MATLAB Code\Annotation GUI\';

% prefix file name of the trained annotator MAT file
fname = 'V3V100001_010';

load([dirname fname '_trainedAnnotator.mat'])

d = Annotator.dim;
maskMat2Vec = triu(true(d));
m = d*(d+1)/2;
N = length(Annotator.Y);
K = length(unique(Annotator.Y));
X = zeros(N,m);
% vectorize the upper triangular part of the covariance matrices to write into a text file
for i = 1:N
    X(i,:) = Annotator.X{i}(maskMat2Vec)';
end


% class counts and label names
fid = fopen(['data_' fname '.txt'],'w');
fprintf(fid,'%d %d %d ',N,d,K);
for i = 1:K
    fprintf(fid,'%d %s ',nnz(Annotator.Y==i),Annotator.labels{i});
end
fprintf(fid,'\n');

% co-occurrence matrix
for i = 1:K
    for j = 1:K
        fprintf(fid,'%0.6f ',Annotator.COMat(i,j));
    end
    fprintf(fid,'\n');
end

% class label and (vectorized) covariance descriptor
for i = 1:N
    fprintf(fid,'%d ',Annotator.Y(i));
    for j = 1:m
        fprintf(fid,'%.12f ',X(i,j));
    end
    fprintf(fid,'\n');
end
fclose(fid);