
#ifndef __KDECLASS_H__
#define __KDECLASS_H__

////////////////////////////////////////////////////////////////////////////////////////////////////
// includes
#include "covdesc.h"

// defines
#define MAX_ITERS_KDE 25
#define LEARN_BANDWIDTH_THRESHOLD 1e-8
#define PI CV_PI
////////////////////////////////////////////////////////////////////////////////////////////////////

/*************************************************************************************************/
class KDEclass
{
	/*************************************************************************************************/
	private:
	/*************************************************************************************************/
		//------------------------------------------------------------------------------------------------
		// PRIVATE VARIABLES
		//------------------------------------------------------------------------------------------------
		

		//------------------------------------------------------------------------------------------------
		// PRIVATE FUNCTIONS
		//------------------------------------------------------------------------------------------------


	/*************************************************************************************************/
	public:
	/*************************************************************************************************/
		//------------------------------------------------------------------------------------------------
		// PUBLIC VARIABLES
		//------------------------------------------------------------------------------------------------

		int dim;						// dimension of covariance descriptors

		int N;						// number of data points

		int label;					// label number

		string labelname;				// labelname

		double sigma2;					// squared KDE bandwidth

		CovarianceDescriptor* covdesc;	// pointer to covariance descriptors

		vnl_matrix<double> D;			// matrix squared distances 

		//------------------------------------------------------------------------------------------------
		// PUBLIC FUNCTIONS
		//------------------------------------------------------------------------------------------------
		// CONSTRUCTORS

		// default constructor
		KDEclass();


		// DESTRUCTOR
		~KDEclass();


		// compute distance matrix
		void computeDistanceMatrix();

		// learn KDE bandwidth
		void learnKDEbandwidth();


		// compute probability estimate
		vnl_vector<double> estimateKDEprobability(CovarianceDescriptor* test, int Ntest);

		// // compute probability estimate with added data points
		// vnl_vector<double> estimateKDEprobability_augmented(CovarianceDescriptor* test, int Ntest);
	/*************************************************************************************************/
};


/*************************************************************************************************/

/*************************************************************************************************/



#endif