/*-------------------------------------------------------------------------------
    AUTHOR	:	KEDAR PATWARDHAN
    DATE	:	19 JAN 2005
    DESCRIPTION	:	GENERAL UTILITIES ( I HAVEN'T BEEN ABLE TO CATEGORIZE THEM )
-------------------------------------------------------------------------------*/

#ifndef		__GENERALUTILS_H__
#define		__GENERALUTILS_H__

#include "cv.h"
/*#include "cvaux.h"*/
#include "highgui.h"
#include "math.h"
#include "imgiter.h"
#include <iostream>
#include <stdio.h>
#include <direct.h>

#include <deque>
using namespace std;

/*	SIMPLE MATRIX INITIALIZATIONS	*/
void setOneMask(IplImage* A);

/*	MATRIX TYPE CONVERSIONS	*/
void convert8Uto32F	( IplImage* src8u , IplImage* dst32f);
void convert32Fto8U	( IplImage* src32f, IplImage* dst8u );
void convert64Fto8U ( IplImage* src64f, IplImage* dst8u );

/*	SIMPLE FILTER INITIALIZATIONS	*/
void createGaussianWeights( IplImage* gMat, float sig=1.0 );

/*	DISPLAY A GIVEN IMAGE AND WAIT	*/
void displayImage( IplImage* img, char* wname=0, int waitTimeInMiliSec=0 );
void displayMarkedBoundary( IplImage* img, CvRect bound, char* wname=0, int waitTimeInMiliSec=0 );

/*	SPLIT AND MERGE IMAGES INTO CHANNELS	*/
void splitChannels( deque<IplImage*> &src, deque<IplImage*> &dst );
void mergeChannels( deque<IplImage*> &src, deque<IplImage*> &dst );

/*	MORPHOLOGICAL FUNCTIONS	*/
const int BORDER_ZERO	= 0;
const int BORDER_ONE	= 1;
IplImage* getBorderMask( IplImage* mask, int param=BORDER_ZERO );

/*	CONVERT BGR (UCHAR) TO rgs	*/
void convertBGRtoRGS( IplImage* BGR, IplImage* RGS );
IplImage* convertGRAYtoBGR( IplImage* Gray );
void convertGRAYtoBGR( IplImage* Gray, IplImage* bgr );

/*	SAMPLE A GIVEN "UCHAR" MASK UNIFORMLY	*/
void sample_uniformly( IplImage* sample_mask, double percent_sample );

/*	REFINE (MORPHOLOGICALLY) MASK, GIVEN WIN-SIZE
	AND MINIMUM % OF "HIGH" VALUES	*/
void morph_refine_mask( IplImage* mask, CvPoint winsize = cvPoint(5,5), double percent_hi = 0.1 );

/* DIVIDE ENTIRE IMAGE BY A SCALAR */
void DivS(IplImage* src32f, double scale);

/*	INLINE FUNCTIONS	*/
//CV_INLINE string sgetcwd() 
//{
//    char buf[256];
//    if (getcwd(buf, sizeof(buf)) != NULL)
//	{
//        return buf;
//	}
//    else
//	{
//        return "";
//	}
//}

#endif

