// imageannotation.cpp : Defines the entry point for the console application.
//

// main include
#include "stdafx.h"

// my includes
#include "segmentimage.h"
#include "imgiter.h"
#include "generalutils.h"
#include "myarrayutils.h"
#include "imgmath.h"
#include "utility.h"
#include "covdesc.h"
#include "imagedescriptor.h"
#include "imageannotator.h"
#include "KDEclass.h"
#include "video_interface.h"











int main(int argc, char** argv)
{

	if (argc<5)
	{
		cerr << endl << "Usage : imageannotation.exe videoname.ext frameNum resizefactor trainData.txt" << endl;
		return -1;
	}

	// create an ImageAnnotator object reading in from the training text file
	ImageAnnotator imAnnot = ImageAnnotator(argv[4]);


	// create a VideoInterface object for reading in frames from the video
	VideoInterface video(argv[1],atof(argv[3]));

	// query a certain frame 
	video.QueryFrame(atoi(argv[2]));

	// perform segmentation and feature extraction from the image
	ImageDescriptor seg = segmentimage(video.im);

	// estimate the class labels for the regions in the image	
	Prediction* Y = imAnnot.EstimateClassLabels(seg.covdesc, seg.numRegions);

	// refine the prediction
	vnl_vector<double> newY = imAnnot.RefinePrediction(Y, seg);


	cvNamedWindow("image");
	cvShowImage("image",video.im);
	cout << endl;

	for (int i=0;i<newY.size();i++)
	{
		cout << newY(i) << "   " << imAnnot.myKDEs[(int) newY(i)].labelname << endl;
		seg.ShowMask(i);
	}
	cout << endl;
	cvDestroyWindow("image");


	/*** clean-up ***/
	video.~VideoInterface();


	return 0;
}