
#ifndef __IMAGEANNOTATOR_H__
#define __IMAGEANNOTATOR_H__

////////////////////////////////////////////////////////////////////////////////////////////////////
// includes
#include "covdesc.h"
#include "KDEclass.h"
#include "imagedescriptor.h"
#include "prediction.h"



#define BORDER_THRESH 0.25
#define ECCEN_THRESH 0.80
////////////////////////////////////////////////////////////////////////////////////////////////////


/*************************************************************************************************/
//
//struct Prediction{
//	vnl_vector<double> probs;
//	vnl_vector<long int> label;
//};


/*************************************************************************************************/
class ImageAnnotator
{
	/*************************************************************************************************/
	private:
	/*************************************************************************************************/
		//------------------------------------------------------------------------------------------------
		// PRIVATE VARIABLES
		//------------------------------------------------------------------------------------------------
		

		//------------------------------------------------------------------------------------------------
		// PRIVATE FUNCTIONS
		//------------------------------------------------------------------------------------------------


	/*************************************************************************************************/
	public:
	/*************************************************************************************************/
		//------------------------------------------------------------------------------------------------
		// PUBLIC VARIABLES
		//------------------------------------------------------------------------------------------------

		string fname;					// filename

		int dim;						// dimension of covariance descriptors

		int N;						// number of training data points

		int K;						// number of classes

		vnl_matrix<double> COmat;		// co-occurrence matrix

		CovarianceDescriptor* covdesc;	// covariance descriptors		

		CvMat* labels;					// vector of labels

		KDEclass* myKDEs;				// set of KDEclass objects, one per class

		//------------------------------------------------------------------------------------------------
		// PUBLIC FUNCTIONS
		//------------------------------------------------------------------------------------------------
		// CONSTRUCTORS

		// default constructor
		ImageAnnotator(string filename);


		// DESTRUCTOR
		~ImageAnnotator();


		// estimate class labels & probabilities
		Prediction* EstimateClassLabels(CovarianceDescriptor* test, int Ntest);

		// refine labels 
		vnl_vector<double> RefinePrediction(Prediction* pred, ImageDescriptor img);

	/*************************************************************************************************/
};


/*************************************************************************************************/

/*************************************************************************************************/



#endif