
#ifndef __IMAGEDESCRIPTOR_H__
#define __IMAGEDESCRIPTOR_H__


////////////////////////////////////////////////////////////////////////////////////////////////////
// includes
#include "covdesc.h"
////////////////////////////////////////////////////////////////////////////////////////////////////

/*************************************************************************************************/
class ImageDescriptor
{
	/*************************************************************************************************/
	private:
	/*************************************************************************************************/
		//------------------------------------------------------------------------------------------------
		// PRIVATE VARIABLES
		//------------------------------------------------------------------------------------------------
		

		//------------------------------------------------------------------------------------------------
		// PRIVATE FUNCTIONS
		//------------------------------------------------------------------------------------------------

		void MakeNhoodGraph();

		void ComputeGeometrics();

	/*************************************************************************************************/
	public:
	/*************************************************************************************************/
		//------------------------------------------------------------------------------------------------
		// PUBLIC VARIABLES
		//------------------------------------------------------------------------------------------------

		int numRegions;				// number of image regions

		CvSize imsize;					// image size

		IplImage* segmentMask;			// segmentation mask

		IplImage** masks;				// masks corresponding to the image regions

		long int* numPix;				// number of pixels in each of the image regions

		int dim;						// dimension of covariance descriptor

		CovarianceDescriptor* covdesc;	// covariance descriptors

		vnl_matrix<double> nhoodgraph;	// neigborhood graph

		CvMoments* moments;				// image region moments

		vnl_vector<double> eccentricity;	// eccentricities of image regions


		//------------------------------------------------------------------------------------------------
		// PUBLIC FUNCTIONS
		//------------------------------------------------------------------------------------------------
		// CONSTRUCTOR
		ImageDescriptor(IplImage** images, IplImage* segMask, int numSegs, int inputDim);


		void ShowMask(int i);

		// DESTRUCTOR
		~ImageDescriptor();


	/*************************************************************************************************/
};


/*************************************************************************************************/


#endif