
//	standard includes
#include "stdafx.h"
#include	"math.h"

//	my includes
#include "prediction.h"
#include "myarrayutils.h"

/*************************************************************************************************/
//------------------------------------------------------------------------------------------------
// PRIVATE FUNCTIONS
//------------------------------------------------------------------------------------------------
/*************************************************************************************************/



/*************************************************************************************************/
/*************************************************************************************************/
/*************************************************************************************************/






/*************************************************************************************************/
//------------------------------------------------------------------------------------------------
// PUBLIC FUNCTIONS
//------------------------------------------------------------------------------------------------
/*************************************************************************************************/


// default constructor
Prediction::Prediction()
{
}


void Prediction::Create(vnl_vector<double> inpProbs)
{
	K = inpProbs.size();
	probs.set_size(K);
	label.set_size(K);

	// normalize
	inpProbs /= inpProbs.sum();

	probs = inpProbs;
	for (int i=0;i<K;i++)
		label(i) = i;

	// sort labels in descending order of probability 
	SortLabels();
	
	/*for (int j=0;j<K;j++)
		cout << "label = " << label(j) << " ; prob " << probs(j) << endl;
	cout << endl;*/
}

/*************************************************************************************************/

int Prediction::MLlabel()
{
	return label(0);
}

/*************************************************************************************************/

// sort labels in descending order of probability 
void Prediction::SortLabels()
{
	vnl_vector<double> myprobs(K,0.0);
	vnl_vector<int> mylabel(K,0);

	int p;
	for (int j=0;j<K;j++)
	{
		p = probs.arg_max();
		mylabel(j) = label(p);
		myprobs(j) = probs(p);
		probs(p) = 0.0;
	}
	label = mylabel;
	probs = myprobs;

	// Best-vs-Second-Best ratio
	BvSB = probs(0)/probs(1);
}

/*************************************************************************************************/


// DESTRUCTOR
Prediction::~Prediction()
{

}

/*************************************************************************************************/


/*************************************************************************************************/


/*************************************************************************************************/
