
#ifndef __PREDICTION_H__
#define __PREDICTION_H__

////////////////////////////////////////////////////////////////////////////////////////////////////
// includes

////////////////////////////////////////////////////////////////////////////////////////////////////

/*************************************************************************************************/
class Prediction
{
	/*************************************************************************************************/
	private:
	/*************************************************************************************************/
		//------------------------------------------------------------------------------------------------
		// PRIVATE VARIABLES
		//------------------------------------------------------------------------------------------------
		

		//------------------------------------------------------------------------------------------------
		// PRIVATE FUNCTIONS
		//------------------------------------------------------------------------------------------------


	/*************************************************************************************************/
	public:
	/*************************************************************************************************/
		//------------------------------------------------------------------------------------------------
		// PUBLIC VARIABLES
		//------------------------------------------------------------------------------------------------

		int K;

		vnl_vector<double> probs;

		vnl_vector<int> label;

		// Best-vs-Second-Best ratio
		double BvSB;

		//------------------------------------------------------------------------------------------------
		// PUBLIC FUNCTIONS
		//------------------------------------------------------------------------------------------------
		// CONSTRUCTORS

		// default constructor
		Prediction();

		// create from the given probability vector
		void Create(vnl_vector<double> inpProbs);

		// get maximum probable label
		int MLlabel();

		// sort labels in descending order of probability 
		void SortLabels();


		// DESTRUCTOR
		~Prediction();

	/*************************************************************************************************/
};


/*************************************************************************************************/

/*************************************************************************************************/



#endif