
#ifndef __VIDEO_INTERFACE_H__
#define __VIDEO_INTERFACE_H__


////////////////////////////////////////////////////////////////////////////////////////////////////
// includes

////////////////////////////////////////////////////////////////////////////////////////////////////

/*************************************************************************************************/
class VideoInterface
{
	/*************************************************************************************************/
	private:
	/*************************************************************************************************/
		//------------------------------------------------------------------------------------------------
		// PRIVATE VARIABLES
		//------------------------------------------------------------------------------------------------
		
		string videoname;
		
		CvCapture* capture;

		IplImage* inpim;
		
		int width;		
		int height;
		int maxFrames;

		CvSize imsize;

		bool resizeImage;

		double resizeFactor;

		//------------------------------------------------------------------------------------------------
		// PRIVATE FUNCTIONS
		//------------------------------------------------------------------------------------------------

	/*************************************************************************************************/
	public:
	/*************************************************************************************************/
		//------------------------------------------------------------------------------------------------
		// PUBLIC VARIABLES
		//------------------------------------------------------------------------------------------------


		IplImage* im;

		//------------------------------------------------------------------------------------------------
		// PUBLIC FUNCTIONS
		//------------------------------------------------------------------------------------------------

		// CONSTRUCTOR
		VideoInterface(char* name, double resize = 1.0);


		// Query the next frame
		void QueryFrame();

		// Query a particular frame number
		void QueryFrame(long int frameNumber);


		// DESTRUCTOR
		~VideoInterface();


	/*************************************************************************************************/
};


/*************************************************************************************************/


#endif